#import uuid
#import platform
#from charmhelpers.core.hosGt import service_running, service_start
#from charmhelpers.fetch import apt_install, filter_installed_packages
from charmhelpers.core.hookenv import (
    config,
    log,
    relation_get,
    relation_ids,
    related_units,
    service_name,
    unit_get,
    ERROR,
)

def sanitize_targets(targets):
    """Convert yaml config targets into prometheus yaml format
    """
    if type(targets) in (type(''), type(u'')):
        targets = map(lambda x: x.strip(), targets.split(','))

    if type(targets) == type([]):
        return "['"+"', '".join(targets)+"']"
    else:
        return ''


class CollectdExporterContext(object):
    interfaces = ['target']

    def __call__(self):
        static_targets = sanitize_targets(config('static-targets'))

        ctxt = {
            'static_targets': static_targets,
            'rules': config('rules'),
            'scrape_interval': config('scrape-interval'),
            'evaluation_interval': config('evaluation-interval')
        }

        return ctxt
