from mock import patch, call, MagicMock

from collections import OrderedDict
import os

os.environ['JUJU_UNIT_NAME'] = 'prometheus'
import prometheus_utils as prometheus_utils

from test_utils import (
    CharmTestCase,
)

TO_PATCH = [
    # helpers.core.hookenv
    'config',
    'log',
    # fetch
    'add_source',
    'apt_update',
    'apt_upgrade',
    'apt_install',
    'service_stop',
    'service_start'
]


DPKG_OPTIONS = [
    '--option', 'Dpkg::Options::=--force-confnew',
    '--option', 'Dpkg::Options::=--force-confdef',
]


class TestPrometheusUtils(CharmTestCase):

    def setUp(self):
        super(TestPrometheusUtils, self).setUp(prometheus_utils, TO_PATCH)
        self.config.side_effect = self.test_config.get_all

    def test_creates_restart_map_all_enabled(self):
        'It creates correct restart map when all services enabled'
        ex_map = OrderedDict([
            ('/etc/prometheus/prometheus.yml', ['prometheus']),
        ])
        self.assertEquals(prometheus_utils.restart_map(), ex_map)

    def test_list_services(self):
        'It returns a list of services associate with this charm'
        ex_list = ['prometheus']
        self.assertEquals(prometheus_utils.services(), ex_list)
